// override.cpp - LCTextOut
// 2006/09/27

#include "override.h"
#include <malloc.h>		// _alloca

#pragma comment(lib, "Gdi32.lib")
#pragma comment(lib, "User32.lib")

UINT g_Quality = 0;
UINT g_Weight = 0;
UINT g_Enhance = 0;
UINT g_UseSubPixel = 0;
UINT g_SubPixelDirection = 0;
float g_MaxHeight = 0;
UINT g_ForceAntialiasedQuality = 0;

BOOL g_IsWinXPorLater = FALSE;

int  g_Scale = 1;

#define MAX_EXCLUDES 32
struct StringHash {
	DWORD	hash;
	WCHAR	name[LF_FACESIZE];
	
	StringHash() {}
	StringHash(LPCWSTR s)
	{
		Init(s);
	}
	void Init(LPCWSTR s)
	{
		wcsncpy(name, s, LF_FACESIZE);
		_UpdateHash();
	}
	bool operator ==(const StringHash& x) const
	{
		return !(hash != x.hash || wcscmp(name, x.name) != 0);
	}
	void _UpdateHash()
	{
		DWORD dw = 0;
		LPWSTR p;
		for (p = name; *p; p++) {
			dw <<= 3;
			dw ^= *p;
		}
		hash = dw;
	}
} g_ExcludeList[MAX_EXCLUDES];

// INIt@Cǂݍ
void LoadSettings(HMODULE hModule){
	WCHAR szFileName[MAX_PATH + 1] = L"";
	// DLL̃tpX擾
	GetModuleFileName(hModule, szFileName, MAX_PATH);
	// gq".ini"ɒu
	lstrcpy(szFileName + lstrlen(szFileName) - 3, L"ini");
	// eݒǂݍ
	// INIt@C̗:
	// [General]
	// Quality=1
	// Weight=0
        // Enhance=0
	// UseSubPixel=0
	// SubPixelDirection=0
	// MaxHeight=0
	// ForceAntialiasedQuality=0
	g_Quality = GetPrivateProfileInt(L"General",L"Quality",2,szFileName);
	g_Weight = GetPrivateProfileInt(L"General",L"Weight",0,szFileName);
  	g_Enhance = GetPrivateProfileInt(L"General",L"Enhance",0,szFileName);
	g_UseSubPixel = GetPrivateProfileInt(L"General",L"UseSubPixel",0,szFileName);
	g_SubPixelDirection = GetPrivateProfileInt(L"General",L"SubPixelDirection",0,szFileName);
	g_MaxHeight = (float)GetPrivateProfileInt(L"General",L"MaxHeight",0,szFileName);
	g_ForceAntialiasedQuality = GetPrivateProfileInt(L"General",L"ForceAntialiasedQuality",0,szFileName);

	// OS̃o[WXPȍ~ǂ
	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx (&osvi);
	g_IsWinXPorLater = ((osvi.dwMajorVersion > 5) || ((osvi.dwMajorVersion == 5) && (osvi.dwMinorVersion >= 1)));

	// [Exclude]ZNV珜OtHgXgǂݍ
	memset(&g_ExcludeList, 0, sizeof(g_ExcludeList));

	WCHAR  buffer [4096];
	WCHAR* p = buffer;
	UINT   nb = 0;
	*p = '\0';
	GetPrivateProfileSection(L"Exclude", p, 4096, szFileName);
	while(*p) {
		bool b = false;
		StringHash* exclist = g_ExcludeList;
		StringHash str(p);
		for(UINT i=0 ; i < nb ; i++) {
			if(exclist[i] == str) {
				b = true;
				break;
			}
		}
		if(!b) {
			if(nb < MAX_EXCLUDES) {
				exclist[nb++] = str;
			}
		}
		while(*p) p++;
		p++;
	}

	switch(g_Quality) {
	case 3:  g_Scale = 4; break;
	case 2:  g_Scale = 3; break;
	case 1:  g_Scale = 2; break;
	default: g_Scale = 1; break;
	}
}

BOOL IsFontExcluded(const LPCWSTR lpszFaceName){
	StringHash* exclist = g_ExcludeList;
	StringHash str(lpszFaceName);
	for(UINT i=0 ; i < MAX_EXCLUDES && exclist[i].hash ; i++) {
		if(exclist[i] == str)
			return TRUE;
	}
	return FALSE;
}
BOOL IsFontExcluded(const LPCSTR lpszFaceName){
	int bufferLength = MultiByteToWideChar(CP_ACP, 0, lpszFaceName, LF_FACESIZE, 0, 0);
	LPWSTR lpszUnicode = (LPWSTR)malloc(bufferLength * 2);
	MultiByteToWideChar(CP_ACP, 0, lpszFaceName, LF_FACESIZE, lpszUnicode, bufferLength);
	BOOL b = IsFontExcluded(lpszUnicode);
	free(lpszUnicode);
	return b;
}

// LDCǂ`FbN
BOOL IsValidDC(const HDC hdc){
	if (GetDeviceCaps(hdc, TECHNOLOGY) != DT_RASDISPLAY) return FALSE;
	// ŃtHg`FbNs
	WCHAR szFaceName[LF_FACESIZE] = L"";
	GetTextFaceW(hdc, LF_FACESIZE, szFaceName);
	if (IsFontExcluded(szFaceName)) return FALSE;
	return TRUE;
}

// DrawChar: GetGlyphOutlineW ňꕶ`
SHORT DrawChar(HDC hdc, int nXStart, int nYStart, UINT uChar, BOOL UseGlyphIndex, const RECT* lprc)
{
	GLYPHMETRICS gm;
	TEXTMETRIC   tm;
	LOGFONT      lf;
	HFONT        hFont, hPrevFont;
	HDC          hCanvasDC;
	HBITMAP      hCanvasBitmap, hPrevBitmap;
	BITMAPINFO   bi;
	BYTE         r, g, b;
	MAT2         mat = {{0,3}, {0,0}, {0,0}, {0,1}}; // ϊsŉɂ̂3{ɈL΂
	DWORD		 buflen, bufWidth, ox, oy;
	LPBYTE		 lpPixels;
	BYTE         *buf;

	GetTextMetrics(hdc, &tm);
	r = GetRValue(GetTextColor(hdc));
	g = GetGValue(GetTextColor(hdc));
	b = GetBValue(GetTextColor(hdc));
	
	UINT uFormat = UseGlyphIndex ? GGO_GRAY8_BITMAP | GGO_GLYPH_INDEX : GGO_GRAY8_BITMAP;
	// GetGlyphOutlineW
	buflen = GetGlyphOutline(hdc, uChar, uFormat, &gm, 0, NULL, &mat);
	if (buflen == GDI_ERROR)  return NULL;
	if (gm.gmBlackBoxX < 3)   return (gm.gmCellIncX + (3 - (gm.gmCellIncX % 3)) % 3) / 3;
	// `ʒu
	ox = gm.gmptGlyphOrigin.x / 3;
	oy = tm.tmAscent - gm.gmptGlyphOrigin.y;
	if (lprc != NULL) {
		if (nXStart + ox > lprc->right)  return (gm.gmCellIncX + (3 - (gm.gmCellIncX % 3)) % 3) / 3;
		if (nYStart + oy > lprc->bottom) return (gm.gmCellIncX + (3 - (gm.gmCellIncX % 3)) % 3) / 3;
		if (nXStart + ox + (gm.gmBlackBoxX / 3) < lprc->left) return (gm.gmCellIncX + (3 - (gm.gmCellIncX % 3)) % 3) / 3;
		if (nYStart + oy +  gm.gmBlackBoxY      < lprc->top)  return (gm.gmCellIncX + (3 - (gm.gmCellIncX % 3)) % 3) / 3;
	}
	// obt@ 4bytes ȃACg
	bufWidth = gm.gmBlackBoxX + (4 - (gm.gmBlackBoxX % 4)) % 4;
	buf      = new BYTE[buflen];
	GetGlyphOutlineW(hdc, uChar, uFormat, &gm, buflen, buf, &mat);
	
	// obNobt@쐬
	ZeroMemory(&bi, sizeof(BITMAPINFO));
	bi.bmiHeader.biSize        = sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biBitCount    = 32;
	bi.bmiHeader.biPlanes      = 1;
	bi.bmiHeader.biWidth       = (gm.gmBlackBoxX + (3 - (gm.gmBlackBoxX % 3)) % 3) / 3;
	bi.bmiHeader.biHeight      = -(gm.gmBlackBoxY);
	bi.bmiHeader.biCompression = BI_RGB;
	hCanvasDC     = CreateCompatibleDC(hdc);
	hCanvasBitmap = CreateDIBSection(hdc, &bi, DIB_RGB_COLORS, (void **)&lpPixels, NULL, 0);
	hPrevBitmap   = (HBITMAP)SelectObject(hCanvasDC, hCanvasBitmap);
	// wiRs[
	BitBlt(hCanvasDC, 0, 0, bi.bmiHeader.biWidth, -bi.bmiHeader.biHeight, hdc, nXStart + ox, nYStart + oy, SRCCOPY);

	// 3{ɐLтĂobt@ATusNZ_O(RGB)
	// [̃sNZɂẮAʂɑΏ
	DWORD bufline = 0;
	DWORD dx = 0;
	BYTE  ra, ga, ba;
	int   x = 0;
	int   y = 0;
	
	for (y = 0; y < gm.gmBlackBoxY; y++) {
		/*
		for (x = 3; x < gm.gmBlackBoxX; x += 3) {
			ra = (255 * buf[bufline + x + 0]) >> 6;
			ga = (255 * buf[bufline + x + 1]) >> 6;
			ba = (255 * buf[bufline + x + 2]) >> 6;
			lpPixels[dx + 0] = (lpPixels[dx + 0] * (255 - ba) + b * ba) / 255;
			lpPixels[dx + 1] = (lpPixels[dx + 1] * (255 - ga) + g * ga) / 255;
			lpPixels[dx + 2] = (lpPixels[dx + 2] * (255 - ra) + r * ra) / 255;
			dx += 4;
		}
		*/
		
		ra = (255 * ((0 + buf[bufline + 0 + 1]) * 1 / 9 +
		             (0 + buf[bufline + 0 + 0]) * 2 / 9 +
		             (0) * 3 / 9))
					 >> 6;
		ga = (255 * ((0 + buf[bufline + 0 + 2]) * 1 / 9 +
		             (0 + buf[bufline + 0 + 1]) * 2 / 9 +
		             (buf[bufline + 0 + 0]) * 3 / 9))
					 >> 6;
		ba = (255 * ((0 + buf[bufline + 0 + 3]) * 1 / 9 +
		             (buf[bufline + 0 - 0] + buf[bufline + 0 + 2]) * 2 / 9 +
		             (buf[bufline + 0 + 1]) * 3 / 9))
					 >> 6;
		lpPixels[dx + 0] = (lpPixels[dx + 0] * (255 - ba) + b * ba) / 255;
		lpPixels[dx + 1] = (lpPixels[dx + 1] * (255 - ga) + g * ga) / 255;
		lpPixels[dx + 2] = (lpPixels[dx + 2] * (255 - ra) + r * ra) / 255;
		dx += 4;
		for (x = 3; x < gm.gmBlackBoxX-3; x += 3) {
			ra = (255 * ((buf[bufline + x - 3] + buf[bufline + x + 1]) * 1 / 9 +
			             (buf[bufline + x - 2] + buf[bufline + x + 0]) * 2 / 9 +
			             (buf[bufline + x - 1]) * 3 / 9))
						 >> 6;
			ga = (255 * ((buf[bufline + x - 2] + buf[bufline + x + 2]) * 1 / 9 +
			             (buf[bufline + x - 1] + buf[bufline + x + 1]) * 2 / 9 +
			             (buf[bufline + x + 0]) * 3 / 9))
						 >> 6;
			ba = (255 * ((buf[bufline + x - 1] + buf[bufline + x + 3]) * 1 / 9 +
			             (buf[bufline + x - 0] + buf[bufline + x + 2]) * 2 / 9 +
			             (buf[bufline + x + 1]) * 3 / 9))
						 >> 6;
			lpPixels[dx + 0] = (lpPixels[dx + 0] * (255 - ba) + b * ba) / 255;
			lpPixels[dx + 1] = (lpPixels[dx + 1] * (255 - ga) + g * ga) / 255;
			lpPixels[dx + 2] = (lpPixels[dx + 2] * (255 - ra) + r * ra) / 255;
			dx += 4;
		}
		x =  gm.gmBlackBoxX-1;
		ra = (255 * ((buf[bufline + x - 3] + 0) * 1 / 9 +
			         (buf[bufline + x - 2] + buf[bufline + x + 0]) * 2 / 9 +
			         (buf[bufline + x - 1]) * 3 / 9))
					 >> 6;
		ga = (255 * ((buf[bufline + x - 2] + 0) * 1 / 9 +
			         (buf[bufline + x - 1] + 0) * 2 / 9 +
			         (buf[bufline + x + 0]) * 3 / 9))
					 >> 6;
		ba = (255 * ((buf[bufline + x - 1] + 0) * 1 / 9 +
			         (buf[bufline + x - 0] + 0) * 2 / 9 +
			         (0) * 3 / 9))
				     >> 6;
		lpPixels[dx + 0] = (lpPixels[dx + 0] * (255 - ba) + b * ba) / 255;
		lpPixels[dx + 1] = (lpPixels[dx + 1] * (255 - ga) + g * ga) / 255;
		lpPixels[dx + 2] = (lpPixels[dx + 2] * (255 - ra) + r * ra) / 255;		
		dx += 4;
		
		bufline += bufWidth;
	}
	
	delete[] buf;

	// ]
	RECT rc, rcClip;
	SetRect(&rc, nXStart + ox, nYStart + oy, nXStart + ox + bi.bmiHeader.biWidth, nYStart + oy - bi.bmiHeader.biHeight);
	if (lprc) {
		if (UnionRect(&rcClip, &rc, lprc)) {
			BitBlt(hdc, rcClip.left, rcClip.top, rcClip.right - rcClip.left, rcClip.bottom - rcClip.top, hCanvasDC, rcClip.left - nXStart - ox, rcClip.top - nYStart - oy, SRCCOPY);
		}
	} else {
		BitBlt(hdc, nXStart + ox, nYStart + oy, bi.bmiHeader.biWidth, -bi.bmiHeader.biHeight, hCanvasDC, 0, 0, SRCCOPY);
	}
	SelectObject(hCanvasDC, hPrevBitmap);
	DeleteObject(hCanvasBitmap);
	DeleteDC(hCanvasDC);
	
	// ɐiޕԂ
	return (gm.gmCellIncX + (3 - (gm.gmCellIncX % 3)) % 3) / 3;
}

// mȃTCYԂGetTextExtentPoint32
BOOL WINAPI _GetTextExtentPoint32W(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize, BOOL UseGlyphIndex)
{
	MAT2         mat = {{0,3}, {0,0}, {0,0}, {0,1}};
	GLYPHMETRICS gm;
	TEXTMETRIC   tm;
	GetTextMetrics(hdc, &tm);
	DWORD x = 0;	
	UINT uFormat = UseGlyphIndex ? GGO_METRICS | GGO_GLYPH_INDEX : GGO_METRICS;
	for (int i = 0; i < cbString; ++i) {
		if (GetGlyphOutlineW(hdc, lpString[i], uFormat, &gm, 0, NULL, &mat) == GDI_ERROR) return NULL;
		x += gm.gmCellIncX;
	}
	lpSize->cx = (x + (3 - (x % 3)) % 3) / 3;
	lpSize->cy = tm.tmHeight;
	return TRUE;
}
BOOL WINAPI IMPL_GetTextExtentPoint32W(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize)
{
	return _GetTextExtentPoint32W(hdc, lpString, cbString, lpSize, FALSE);
}

BOOL WINAPI IMPL_ExtTextOutW(HDC hdc, int nXStart, int nYStart, UINT fuOptions, CONST RECT *lprc, LPCWSTR lpString, UINT cbString, CONST INT *lpDx)
{
	int x = nXStart;
	int y = nYStart;
	SIZE size;
	int error = 0;
	if (lpString == NULL || cbString == 0 || g_Quality==0) {
		error = 11; //throw
	}
	if (!error) if(!IsValidDC(hdc)) {
		error = 14;	// hdc is invalid
	}
	if (!error) {
		_GetTextExtentPoint32W(hdc, lpString, cbString, &size, fuOptions & ETO_GLYPH_INDEX);
		if (g_MaxHeight > 0) {
			if(size.cy >= g_MaxHeight) //max 26pixel
				error = 13; //throw large size
		}
	}
	if (!error) {
		UINT align = GetTextAlign(hdc);
		if(align & TA_UPDATECP) {
			POINT pt;
			GetCurrentPositionEx(hdc, &pt);
			x = pt.x;
			y = pt.y;
			//MoveToEx(hdc, pt.x + size.cx, pt.y, NULL);
		}
		if (align && TA_CENTER) {
			x = x - (size.cx / 2);
		} else if (align && TA_RIGHT) {
			x -= size.cx;
		}
		if (align && TA_BASELINE) {
			TEXTMETRIC tm;
			GetTextMetrics(hdc, &tm);
			y -= tm.tmAscent;
		} else if (align && TA_BOTTOM) {
			y -= size.cy;
		}
		if ((GetBkMode(hdc) == OPAQUE) || (fuOptions & ETO_OPAQUE)) {
			if (lprc) {
				ORIG_ExtTextOutW(hdc, 0, 0, ETO_OPAQUE, lprc, NULL, 0, NULL);
			} else {
				RECT rc = {x, y, x + size.cx, y + size.cy};
				ORIG_ExtTextOutW(hdc, 0, 0, ETO_OPAQUE, &rc, NULL, 0, NULL);
			}
		}
		
		SHORT cx;
		for(int i = 0; i < cbString; ++i) {

			cx = DrawChar(hdc, x, y, lpString[i], fuOptions & ETO_GLYPH_INDEX, (fuOptions & ETO_CLIPPED) ? lprc : NULL);
			if (cx == NULL) {
				error = 2;
				break;
			}
			x += cx;
		}
		/*
		if(align & TA_UPDATECP) {
			MoveToEx(hdc, x + size.cx, y + size.cy, NULL);
		}
		*/
	}
	if (!error)	return TRUE;
	//return ORIG_ExtTextOutW(hdc, nXStart, nYStart, fuOptions, lprc, lpString, cbString, lpDx);
}

//EOF
